Ext.define('DSS.addon.ScreenSceneName', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	getHeight : function() {
		return 66;
	},
	height : '100%',
	scene1:null,
	scene2:null,
	scene3:null,
	scene4:null,
	constructor : function(config) {
		this.scene1 = Ext.create('Ext.form.field.Text',{
			fieldLabel:_('Scene 1'),
			maxLength:12,
			enforceMaxLength:true
		});
		this.scene2 = Ext.create('Ext.form.field.Text',{
			fieldLabel:_('Scene 2'),
			padding:'0 0 0 50',
			maxLength:12,
			enforceMaxLength:true
		});
		this.scene3 = Ext.create('Ext.form.field.Text',{
			fieldLabel:_('Scene 3'),
			maxLength:12,
			enforceMaxLength:true
		});
		this.scene4 = Ext.create('Ext.form.field.Text',{
			fieldLabel:_('Scene 4'),
			padding:'0 0 0 50',
			maxLength:12,
			enforceMaxLength:true
		});
		var basePanel = Ext.create('Ext.panel.Panel', {
			border : '0',
			height : 66,
			border : false,
			width:700,
			padding : '10 0 7 0',
			layout : {
				type : 'table',
				columns: 2
			},
			items : [this.scene1,this.scene2,this.scene3,this.scene4],
			scroll : 'horizontal'
		});

		var me = this;	

		Ext.apply(this, {
			items : [ basePanel ]
		});
	
		this.callParent(arguments);
	},
	saneValues:false,
	updateSceneNames: function(zone,group,type) {
		this.saneValues=false;
		if (group==8) {
			this.saneValues=true;
			this.scene1.setValue("");
			this.scene2.setValue("");
			this.scene3.setValue("");
			this.scene4.setValue("");
			this.scene1.setFieldLabel(_('Button 1'));
			this.scene2.setFieldLabel(_('Button 2'));
			this.scene3.setFieldLabel(_('Button 3'));
			this.scene4.setFieldLabel(_('Button 4'));
			if (this.lnkFunction!=null)
				this.lnkFunction();
			return;
		} else {
			this.scene1.setFieldLabel(_('Scene 1'));
			this.scene2.setFieldLabel(_('Scene 2'));
			this.scene3.setFieldLabel(_('Scene 3'));
			this.scene4.setFieldLabel(_('Scene 4'));
		}
		
		
		if ((zone==null) || (group==null) || (type==null)) {
			this.saneValues=false;
			if (this.lnkFunction!=null)
				this.lnkFunction();
			return;
		}
		this.saneValues=true;
		switch (type) {
			case 1:
				this.scene1.setValue(dss.staticDataModel.getNameForScene(zone,group,6));
				this.scene2.setValue(dss.staticDataModel.getNameForScene(zone,group,17));
				this.scene3.setValue(dss.staticDataModel.getNameForScene(zone,group,18));
				this.scene4.setValue(dss.staticDataModel.getNameForScene(zone,group,19));
			break;
			case 2:
				this.scene1.setValue(dss.staticDataModel.getNameForScene(zone,group,7));
				this.scene2.setValue(dss.staticDataModel.getNameForScene(zone,group,17));
				this.scene3.setValue(dss.staticDataModel.getNameForScene(zone,group,18));
				this.scene4.setValue(dss.staticDataModel.getNameForScene(zone,group,19));
			break;
			case 3:
				this.scene1.setValue(dss.staticDataModel.getNameForScene(zone,group,8));
				this.scene2.setValue(dss.staticDataModel.getNameForScene(zone,group,17));
				this.scene3.setValue(dss.staticDataModel.getNameForScene(zone,group,18));
				this.scene4.setValue(dss.staticDataModel.getNameForScene(zone,group,19));
			break;
			case 4:
				this.scene1.setValue(dss.staticDataModel.getNameForScene(zone,group,9));
				this.scene2.setValue(dss.staticDataModel.getNameForScene(zone,group,17));
				this.scene3.setValue(dss.staticDataModel.getNameForScene(zone,group,18));
				this.scene4.setValue(dss.staticDataModel.getNameForScene(zone,group,19));
			break;
			case 5:
				this.scene1.setValue(dss.staticDataModel.getNameForScene(zone,group,5));
				this.scene2.setValue(dss.staticDataModel.getNameForScene(zone,group,17));
				this.scene3.setValue(dss.staticDataModel.getNameForScene(zone,group,18));
				this.scene4.setValue(dss.staticDataModel.getNameForScene(zone,group,19));
			break;
			case 6:
				this.scene1.setValue(dss.staticDataModel.getNameForScene(zone,group,33));
				this.scene2.setValue(dss.staticDataModel.getNameForScene(zone,group,20));
				this.scene3.setValue(dss.staticDataModel.getNameForScene(zone,group,21));
				this.scene4.setValue(dss.staticDataModel.getNameForScene(zone,group,22));
			break;
			case 7:
				this.scene1.setValue(dss.staticDataModel.getNameForScene(zone,group,35));
				this.scene2.setValue(dss.staticDataModel.getNameForScene(zone,group,23));
				this.scene3.setValue(dss.staticDataModel.getNameForScene(zone,group,24));
				this.scene4.setValue(dss.staticDataModel.getNameForScene(zone,group,25));
			break;
			case 8:
				this.scene1.setValue(dss.staticDataModel.getNameForScene(zone,group,37));
				this.scene2.setValue(dss.staticDataModel.getNameForScene(zone,group,26));
				this.scene3.setValue(dss.staticDataModel.getNameForScene(zone,group,27));
				this.scene4.setValue(dss.staticDataModel.getNameForScene(zone,group,28));
			break;
			case 9:
				this.scene1.setValue(dss.staticDataModel.getNameForScene(zone,group,39));
				this.scene2.setValue(dss.staticDataModel.getNameForScene(zone,group,29));
				this.scene3.setValue(dss.staticDataModel.getNameForScene(zone,group,30));
				this.scene4.setValue(dss.staticDataModel.getNameForScene(zone,group,31));
			break;
			case 10:
				this.scene1.setValue(dss.staticDataModel.getNameForScene(zone,group,6));
				this.scene2.setValue(dss.staticDataModel.getNameForScene(zone,group,20));
				this.scene3.setValue(dss.staticDataModel.getNameForScene(zone,group,21));
				this.scene4.setValue(dss.staticDataModel.getNameForScene(zone,group,22));
			break;
			case 11:
				this.scene1.setValue(dss.staticDataModel.getNameForScene(zone,group,7));
				this.scene2.setValue(dss.staticDataModel.getNameForScene(zone,group,23));
				this.scene3.setValue(dss.staticDataModel.getNameForScene(zone,group,24));
				this.scene4.setValue(dss.staticDataModel.getNameForScene(zone,group,25));
			break;
			case 12:
				this.scene1.setValue(dss.staticDataModel.getNameForScene(zone,group,8));
				this.scene2.setValue(dss.staticDataModel.getNameForScene(zone,group,26));
				this.scene3.setValue(dss.staticDataModel.getNameForScene(zone,group,27));
				this.scene4.setValue(dss.staticDataModel.getNameForScene(zone,group,28));
			break;
			case 13:
				this.scene1.setValue(dss.staticDataModel.getNameForScene(zone,group,9));
				this.scene2.setValue(dss.staticDataModel.getNameForScene(zone,group,29));
				this.scene3.setValue(dss.staticDataModel.getNameForScene(zone,group,30));
				this.scene4.setValue(dss.staticDataModel.getNameForScene(zone,group,31));
			break;
		}
		if (this.lnkFunction!=null)
			this.lnkFunction();
	},
	reset : function() {
		this.scene1.setValue('');
		this.scene2.setValue('');
		this.scene3.setValue('');
		this.scene4.setValue('');
		var me=this;
		if (this.lnkFunction==null) {
			this.lnkFunction=function() {
				var cbBoxNotInSync=!me.dssEditor.editControls.keepInSync.getValue();
				if (me.saneValues && cbBoxNotInSync) {
					me.scene1.setDisabled(false);
					me.scene2.setDisabled(false);
					me.scene3.setDisabled(false);
					me.scene4.setDisabled(false);					

					me.scene1.setValue(me.tempValue1);
					me.scene2.setValue(me.tempValue2);
					me.scene3.setValue(me.tempValue3);
					me.scene4.setValue(me.tempValue4);

				} else {
					me.scene1.setDisabled(true);
					me.scene2.setDisabled(true);
					me.scene3.setDisabled(true);
					me.scene4.setDisabled(true);

					me.tempValue1=me.scene1.getValue();
					me.tempValue2=me.scene2.getValue();
					me.tempValue3=me.scene3.getValue();
					me.tempValue4=me.scene4.getValue();
					
					me.scene1.setValue("");
					me.scene2.setValue("");
					me.scene3.setValue("");
					me.scene4.setValue("");

				}
			};
			this.dssEditor.editControls.keepInSync.on({
				change : function () {
					me.lnkFunction();
				}
			});
		}
			
		this.updateSceneNames();
	},
	isValid : function() {
		return true;
	},
	tempValue1:'',
	tempValue2:'',
	tempValue3:'',
	tempValue4:'',
	setValue : function(oldValue) {
		this.scene1.setValue(oldValue.scene1.trimRight());
		this.scene2.setValue(oldValue.scene2.trimRight());
		this.scene3.setValue(oldValue.scene3.trimRight());
		this.scene4.setValue(oldValue.scene4.trimRight());

		var me=this;
		if (this.lnkFunction==null) {
			this.lnkFunction=function() {
				var cbBoxNotInSync=!me.dssEditor.editControls.keepInSync.getValue();
				if (me.saneValues && cbBoxNotInSync) {
					me.scene1.setDisabled(false);
					me.scene2.setDisabled(false);
					me.scene3.setDisabled(false);
					me.scene4.setDisabled(false);					

					me.scene1.setValue(me.tempValue1);
					me.scene2.setValue(me.tempValue2);
					me.scene3.setValue(me.tempValue3);
					me.scene4.setValue(me.tempValue4);

				} else {
					me.scene1.setDisabled(true);
					me.scene2.setDisabled(true);
					me.scene3.setDisabled(true);
					me.scene4.setDisabled(true);

					me.tempValue1=me.scene1.getValue();
					me.tempValue2=me.scene2.getValue();
					me.tempValue3=me.scene3.getValue();
					me.tempValue4=me.scene4.getValue();
					
					me.scene1.setValue("");
					me.scene2.setValue("");
					me.scene3.setValue("");
					me.scene4.setValue("");

				}
			};
			this.dssEditor.editControls.keepInSync.on({
				change : function () {
					me.lnkFunction();
				}
			});
		}
	},
	getValue : function() {
		return {
			scene1:this.scene1.getValue(),
			scene2:this.scene2.getValue(),
			scene3:this.scene3.getValue(),
			scene4:this.scene4.getValue()
		}
	}
});